c     p(x) = x*x + A2*x + A1 
      pure subroutine solve_quadratic(A1,A2,z,k)
      implicit none

      real*8,    intent(in)  :: A1, A2
      real*8,    intent(out) :: z(1:3)
      integer*4, intent(out) :: k

      real*8 Det

      z = 0.0d0

      Det = A2*A2 - 4.0d0*A1

      if(Det .gt. 0.0d0) then
         
         k    = 2
         z(1) = (-A2 + dsqrt(Det)) / 2.0d0
         z(2) = (-A2 - dsqrt(Det)) / 2.0d0

      else

         k = 0

      end if

      return
      end
