      pure subroutine DFT_inv(z,r)
      use blocks
      use Fourier
      implicit none
      complex*16, intent(in)  :: z(0:M)
      real*8,     intent(out) :: r(0:Nm1)

      complex*16 ce
      integer*4  i, j

      r = rz
      do 1, i=0,Nm1
      do 2, j=1,M
      ce = dconjg(E(i*j))
      r(i) = r(i) + two*dreal( z(j) * ce )
 2    continue
      r(i) = r(i) + dreal(z(0))
 1    continue
      r = r/dfloat(N)

      return
      end
