!DIR$ FIXEDFORMLINESIZE:132
      pure subroutine tune_r_3(r)
      use blocks
      implicit none
      real*8, intent(inout) :: r(0:Nm1)

      real*8, dimension(0:Nm1) :: cp1, sp1, cp2, sp2, cp3, sp3, p
      real*8    alpha
      integer*4 i,j,k,info
      logical*4 flag

      INTERFACE

         pure subroutine make_p(i,cp,sp)
         use blocks
         integer*4, intent(in)  :: i
         real*8,    intent(out) :: cp(0:Nm1), sp(0:Nm1)
         end subroutine make_p

         pure subroutine make_alpha(r,p,alpha,flag,info)
         use blocks
         real*8,    intent(in)  :: r(0:Nm1), p(0:Nm1)
         real*8,    intent(out) :: alpha
         logical*4, intent(out) :: flag
         integer*4, intent(out) :: info
         end subroutine make_alpha
      
      END INTERFACE

      do 1, i=Lp1,M
      call make_p(i,cp1,sp1)
      do 1, j=Lp1,M
      call make_p(j,cp2,sp2)
      do 1, k=Lp1,M
      call make_p(k,cp3,sp3)
c
c  cp1 + cp2 + [cp3, sp1, sp2, sp3] :: 4
c
      p = cp1 + cp2 + cp3
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p

      p = cp1 + cp2 + sp1
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p

      p = cp1 + cp2 + sp2
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p

      p = cp1 + cp2 + sp3
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p
c
c  cp1 + cp3 + [sp1, sp2, sp3] :: 3
c
      p = cp1 + cp3 + sp1
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p

      p = cp1 + cp3 + sp2
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p

      p = cp1 + cp3 + sp3
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p
c
c  cp1 + sp1 + [sp2, sp3] :: 2
c
      p = cp1 + sp1 + sp2
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p

      p = cp1 + sp1 + sp3
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p
c
c  cp1 + sp2 + [sp3] :: 1
c
      p = cp1 + sp2 + sp3
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p
c
c  cp2 + cp3 + [sp1, sp2, sp3] :: 3
c
      p = cp2 + cp3 + sp1
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p

      p = cp2 + cp3 + sp2
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p

      p = cp2 + cp3 + sp3
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p
c
c  cp2 + sp1 + [sp2, sp3] :: 2
c
      p = cp2 + sp1 + sp2
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p

      p = cp2 + sp1 + sp3
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p
c
c  cp2 + sp2 + [sp3] :: 1
c
      p = cp2 + sp2 + sp3
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p
c
c  cp3 + sp1 + [sp2, sp3] :: 2
c
      p = cp3 + sp1 + sp2
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p

      p = cp3 + sp1 + sp3
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p
c
c  cp3 + sp2 + [sp3] :: 1
c
      p = cp3 + sp2 + sp3
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p
c
c  sp1 + sp2 + [sp3] :: 1
c
      p = sp1 + sp2 + sp3
      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p

 1    continue

      return
      end
