!DIR$ FIXEDFORMLINESIZE:132
      pure subroutine tune_r_stp(r)
      use blocks
      implicit none
      real*8, intent(inout) :: r(0:Nm1)

      real*8, dimension(0:Nm1) :: cp, sp, p, y
      real*8    alpha, r1, r2, r3
      integer*4 i, j, info
      logical*4 flag

      INTERFACE

         pure subroutine make_p(i,cp,sp)
         use blocks
         integer*4, intent(in)  :: i
         real*8,    intent(out) :: cp(0:Nm1), sp(0:Nm1)
         end subroutine make_p

         pure subroutine make_alpha(r,p,alpha,flag,info)
         use blocks
         real*8,    intent(in)  :: r(0:Nm1), p(0:Nm1)
         real*8,    intent(out) :: alpha
         logical*4, intent(out) :: flag
         integer*4, intent(out) :: info
         end subroutine make_alpha
      
      END INTERFACE


      do 1, j=0,Nm1
      r1   = r(j)
      r2   = r1 - ru
      r3   = r1 + r2
      y(j) = r1*r2*r3
 1    continue

      p = rz

      do 2, i=Lp1,M

      call make_p(i,cp,sp)
      
      r1 = rz
      r2 = rz
      do 3, j=0,Nm1
         r1 = r1 + y(j)*cp(j) 
         r2 = r2 + y(j)*sp(j) 
 3    continue
       
      p = p + r1*cp + r2*sp

 2    continue

      call make_alpha(r,p,alpha,flag,info)
      if(flag) r = r + alpha*p


      return
      end
